#ifndef Desk_h
#define Desk_h
using namespace std;
#include <fstream>
#include <string>
#include <vector>
#include <sys/wait.h>
#include <X11/Xlib.h>
#include <X11/Xft/Xft.h>
#include <Imlib.h>
#include <png.h>
#include <dirent.h>
#include "Icon.h"
#include "Database.h"
class Icon;
class Database;


  class Desk {
    private:
       Icon *FindIcon( Window Win );
       vector<Icon*> Icons;
       int Transparency;
       bool Locked;
       bool HighContrast;
       bool ShadowFlag;
       int ShadowX;
       int ShadowY;
       int BoldVal;

    public:
       Desk();
      ~Desk();

       void LoadOptions();
       void LoadIcons();
       void AddIcon( char *File, char *F, char *Caption, char *Command, int X, int Y );
       void LockDesk();
       void UnlockDesk();
       bool IsLocked();
       void ArrangeIcons();
       void Execute( char *Command );
       void SaveIcons();
       void SaveIcon( Icon *I );
       void Loop();
       int  GetTransparency( );
       bool GetContrast( );
       bool GetShadow(int &x, int &y );

       Display *Dpy;
       Window  Root;
       ImlibData *Data;
       ImlibImage *SpareRoot;

       XftFont *Font;
       XftColor Fore;
       XftColor Back;
       XftColor Shadow;
  };


  extern void Reboot();

#endif //Desk_h
